﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FTD2XX_NET;

namespace PCL6115EV_Sample
{
    public partial class Form1 : Form
    {
        ////////////////////////////////////////////////////////////////////
        private byte[] FtBuff;
        private int FtIndex = 0;
        private uint mstsw = 0;
        private uint sstsw = 0;
        private uint rirq = 0;
        private uint rsts = 0;
        private uint rest = 0;
        private uint rist = 0;
        private uint rcun1 = 0;
        private uint rspd = 0;
        private uint rpls = 0;
        private int CommFlg = 0;
        ////////////////////////////////////////////////////////////////////
        private clsFTDI hFTDI = new clsFTDI();
        private accessPCL hAPCL = new accessPCL();
        FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OK;

        public Form1()
        {
            InitializeComponent();
            this.MaximizeBox = false;//最大化禁止 //No maximization
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //画面中央に配置
            //Arranged in the center of the screen
            this.Left = (System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width - this.Width) / 2;
            this.Top = (System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height - this.Height) / 2;
            this.StartPosition = FormStartPosition.Manual;
            //
            FtBuff = new byte[1024];
            //
            this.l_msts_00.Image = this.imageList1.Images[0];
            this.l_rsts_16.Image = this.imageList1.Images[0];
            this.l_msts_04.Image = this.imageList1.Images[0];
            this.l_msts_05.Image = this.imageList1.Images[0];
            this.l_ssts_08.Image = this.imageList1.Images[0];
            this.l_ssts_09.Image = this.imageList1.Images[0];
            this.l_ssts_10.Image = this.imageList1.Images[0];
            this.l_ssts_11.Image = this.imageList1.Images[0];
            this.l_ssts_12.Image = this.imageList1.Images[0];
            this.l_ssts_13.Image = this.imageList1.Images[0];
            this.l_ssts_14.Image = this.imageList1.Images[0];
            this.l_ssts_15.Image = this.imageList1.Images[0];
            //
            ////////////////////////////////////////////////////////////////////
            FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OK;

            ftStatus = hFTDI.LSI_Open("NPM PCL6115-EV Serial access");

            if (ftStatus != FTDI.FT_STATUS.FT_OK)
            {
                //
                this.timer1.Stop();
                //
                //MessageBox.Show(ftStatus.ToString(), "Error");
                MessageBox.Show(" [ PCL6115-EV ] not found", "Error");
                Close();
            }
            else
            {
                this.timer1.Interval = 100;
                this.timer1.Start();
            }
            //Initial setting
            CommFlg = 100;
        }

        /// <summary>
        /// ソフトウェア終了処理
        /// Software termination processing
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            hFTDI.LSI_Close();
        }

        /// <summary>
        /// ボタンクリック時の処理
        /// Processing when button is clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bt_ccw_Click_1(object sender, EventArgs e)
        {
            String str = (String)((Button)sender).Tag;
            CommFlg = int.Parse(str);
        }

        /// <summary>
        /// 終了ボタンクリック時の処理
        /// Processing when the "Close" button is clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bt_close_Click(object sender, EventArgs e)
        {
            Close();
        }

        /// <summary>
        /// 16進数以外のキー入力を無効化
        /// Disable key input other than hexadecimal
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void t_rirq_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < '0' || '9' < e.KeyChar) &&
                (e.KeyChar < 'A' || 'F' < e.KeyChar) &&
                (e.KeyChar < 'a' || 'f' < e.KeyChar) &&
                (e.KeyChar != '\b')
                )
            {
                e.Handled = true;
            }
        }

        /// <summary>
        /// ステータス、レジスタの値をきりだす
        /// Cut out status and register values
        /// </summary>
        /// <param name="buff"></param>
        private void SetRegData(byte[] buff)
        {
//            mstsw = hAPCL.GetBuffData(buff, 0, 0);
            mstsw = hAPCL.GetBuffData(buff, 1, 0); // FTDI Data = command+data(2byte)
//            sstsw = hAPCL.GetBuffData(buff, 2, 0);
            sstsw = hAPCL.GetBuffData(buff, 4, 0); // FTDI Data = command+data(2byte)
//            rirq = hAPCL.GetBuffData(buff, 4, 1);
            rirq = hAPCL.GetBuffData(buff, 8, 1); // FTDI Data = command+comm+data(4byte)
//            rsts = hAPCL.GetBuffData(buff, 8, 1);
            rsts = hAPCL.GetBuffData(buff, 14, 1); // FTDI Data = command+comm+data(4byte)
//            rest = hAPCL.GetBuffData(buff, 12, 1);
            rest = hAPCL.GetBuffData(buff, 20, 1); // FTDI Data = command+comm+data(4byte)
//            rist = hAPCL.GetBuffData(buff, 16, 1);
            rist = hAPCL.GetBuffData(buff, 26, 1); // FTDI Data = command+comm+data(4byte)
//            rcun1 = hAPCL.GetBuffData(buff, 20, 1);
            rcun1 = hAPCL.GetBuffData(buff, 32, 1); // FTDI Data = command+comm+data(4byte)
//            rspd = hAPCL.GetBuffData(buff, 24, 1);
            rspd = hAPCL.GetBuffData(buff, 38, 1); // FTDI Data = command+comm+data(4byte)
//            rpls = hAPCL.GetBuffData(buff, 28, 1);
            rpls = hAPCL.GetBuffData(buff, 44, 1); // FTDI Data = command+comm+data(4byte)
        }

        /// <summary>
        /// ステータス、レジスタの値を読み出すコマンドの実行
        /// Execution of command to read status and register value
        /// </summary>
        private void readRegs()
        {
            FtIndex = 0;

            hAPCL.Read_STATUS(ref FtBuff, ref FtIndex, 0);//read MSTSW
            hAPCL.Read_STATUS(ref FtBuff, ref FtIndex, 1);//read SSTSW
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xEC);//read RIRQ
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xF1);//read RSTS
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xF2);//read REST
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xF3);//read RIST
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xE3);//read RCUN1
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xF5);//read RSPD
            hAPCL.Read_REG(ref FtBuff, ref FtIndex, 0xF4);//read RPLS
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
            if (ftStatus == FTDI.FT_STATUS.FT_OK)
            {
                ftStatus = hAPCL.GetUsb(ref FtBuff);
                //
                if (ftStatus == FTDI.FT_STATUS.FT_OK)
                {
                    SetRegData(FtBuff);
                }
            }
        }

        /// <summary>
        /// スタータスの状態表示
        /// Display of status
        /// </summary>
        /// <param name="pb"></param>
        /// <param name="status"></param>
        /// <param name="mask"></param>
        /// <param name="type"></param>
        private void SetLed(PictureBox pb, uint status, int mask, int type)
        {
            if((status & mask) == 0)
            {
                pb.Image = this.imageList1.Images[0];     // OFF
            }
            else
            {
                pb.Image = this.imageList1.Images[type];  // ON
            }
        }

        /// <summary>
        /// ステータス、レジスタの値を表示
        /// Display status and register values
        /// </summary>
        /// <param name="lb"></param>
        /// <param name="reg"></param>
        /// <param name="length"></param>
        private void SetRegData(Label lb, uint reg, int length)
        {
            string str;

            if(reg == 0)
            {
                lb.ForeColor = Color.Blue;
            }
            else
            {
                lb.ForeColor = Color.Red;
            }
            //
            str="X" + length.ToString("d");
            lb.Text = reg.ToString(str) + " h";
        }

        /// <summary>
        /// 画面の更新
        /// Update Form
        /// </summary>
        private void SetDisplay()
        {
            //LED
            SetLed(this.l_msts_00, mstsw, 0x0001, 1);
            SetLed(this.l_rsts_16, rsts, 0x00010000, 1);
            SetLed(this.l_msts_04, mstsw, 0x0010, 2);
            SetLed(this.l_msts_05, mstsw, 0x0020, 2);
            SetLed(this.l_ssts_08, sstsw, 0x0100, 1);
            SetLed(this.l_ssts_09, sstsw, 0x0200, 1);
            SetLed(this.l_ssts_10, sstsw, 0x0400, 1);
            SetLed(this.l_ssts_11, sstsw, 0x0800, 3);
            SetLed(this.l_ssts_12, sstsw, 0x1000, 3);
            SetLed(this.l_ssts_13, sstsw, 0x2000, 3);
            SetLed(this.l_ssts_14, sstsw, 0x4000, 3);
            SetLed(this.l_ssts_15, sstsw, 0x8000, 3);
            //Registers
            SetRegData(this.l_mstsw, mstsw, 4);
            SetRegData(this.l_sstsw, sstsw, 4);
            SetRegData(this.l_rirq, rirq, 8);
            SetRegData(this.l_rsts, rsts, 8);
            SetRegData(this.l_rest, rest, 8);
            SetRegData(this.l_rist, rist, 8);
            SetRegData(this.l_rcun1, rcun1, 8);
            SetRegData(this.l_rspd, rspd, 8);
            SetRegData(this.l_rpls, rpls, 8);
        }

        /// <summary>
        /// CCW処理実行
        /// CCW process execution
        /// </summary>
        private void Exec_CCW()
        {
            FtIndex = 0;

            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000001, 0x01, 0x81);// write PRFL (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000400, 0x01, 0x82);// write PRFH (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00002588, 0x01, 0x83);// write PRUR (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0xFFFFF700, 0x01, 0x80);// write PRMV (X-Axis)
            //
            hAPCL.Write_COM(ref FtBuff, ref FtIndex, 0x01, 0x53);//write High speed start 2 (X-Axis)
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
        }

        /// <summary>
        /// CW処理実行
        /// CW process execution
        /// </summary>
        private void Exec_CW()
        {
            FtIndex = 0;

            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000001, 0x01, 0x81);// write PRFL (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000400, 0x01, 0x82);// write PRFH (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00002588, 0x01, 0x83);// write PRUR (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000900, 0x01, 0x80);// write PRMV (X-Axis)
            //
            hAPCL.Write_COM(ref FtBuff, ref FtIndex, 0x01, 0x53);//write High speed start 2 (X-Axis)
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
        }

        /// <summary>
        /// ソフトウェアリセット実行
        /// Software reset execution
        /// </summary>
        private void Exec_SoftReset()
        {
            FtIndex = 0;

            hAPCL.Write_COM(ref FtBuff, ref FtIndex, 0x01, 0x04);//write Software reset (X-Axis)
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
            //
            InitSet();
        }

        /// <summary>
        /// レジスタへのライト処理実行
        /// Execute write processing to register
        /// </summary>
        /// <param name="type"></param>
        private void Exec_WriteReg(int type)
        {
            uint Data = 0;
            byte comm = 0;

            switch (type)
            {
                case 0 :
                    comm = 0xAC;
                    if (this.t_rirq.Text == "")
                    {
                        Data = 0;
                    }
                    else
                    {
                        Data = (uint)(Convert.ToInt32(this.t_rirq.Text, 16));
                    }
                    break;
                case 1:
                    comm = 0xB2;
                    Data = rest;
                    break;
                case 2 :
                    comm = 0xB3;
                    Data = rist;
                    break;
            }
            //
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, Data, 0x01, comm);// write PRFL (X-Axis)
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
        }

        /// <summary>
        /// 初期設定
        /// Initial setting
        /// </summary>
        private void InitSet()
        {
            FtIndex = 0;

            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000002, 0x01, 0x9C);// write RENV1 (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x80001D40, 0x01, 0x9D);// write RENV2 (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x000004AF, 0x01, 0x85);// write PRMG (X-Axis)
            hAPCL.Write_REG(ref FtBuff, ref FtIndex, 0x00000041, 0x01, 0x87);// write PRMD (X-Axis)
            //
            ftStatus = hAPCL.SendUsb(ref FtBuff, ref FtIndex);
        }

        /// <summary>
        /// タイマー処理
        /// Timer processing
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timer1_Tick(object sender, EventArgs e)
        {
            //
            switch(CommFlg)
            {
                case 1://CCW
                    Exec_CCW();
                    break;
                case 2://CW
                    Exec_CW();
                    break;
                case 3://Software reset
                    Exec_SoftReset();
                    break;
                case 4://Write RIRQ
                    Exec_WriteReg(0);
                    break;
                case 5://Clear REST
                    Exec_WriteReg(1);
                    break;
                case 6://Clear RIS
                    Exec_WriteReg(2);
                    break;
                case 100://Initial setting
                    InitSet();
                    break;
            }
            //
            CommFlg = 0;
            //
            readRegs();
            SetDisplay();//
            //
            if(ftStatus != FTDI.FT_STATUS.FT_OK)
            {
                this.timer1.Stop();
                MessageBox.Show("PCL6124-StarterKit connection has been disconnected", "Error");
                Close();
            }
        }
    }
}
